aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/check-lint-count.bash
diff options
context:
space:
mode:
authorJohn Heroy <johnheroy@gmail.com>2015-10-21 12:10:08 -0700
committerJohn Heroy <johnheroy@gmail.com>2015-10-21 12:10:08 -0700
commit451518ff9f375cd3e44926fc2027d2fc36c93833 (patch)
tree9bd1b0d7df82d2be6b66b54613684cdb542f6c57 /scripts/check-lint-count.bash
parentcd94615223e4ea94c31cc8071787a4c3aaf33cd6 (diff)
parent3d9dedb3479875db2bb2b46b09ed413bab8f35cf (diff)
downloadconnectbot-451518ff9f375cd3e44926fc2027d2fc36c93833.tar.gz
connectbot-451518ff9f375cd3e44926fc2027d2fc36c93833.tar.bz2
connectbot-451518ff9f375cd3e44926fc2027d2fc36c93833.zip
Merge remote-tracking branch 'upstream/master'
Diffstat (limited to 'scripts/check-lint-count.bash')
-rwxr-xr-xscripts/check-lint-count.bash57
1 files changed, 57 insertions, 0 deletions
diff --git a/scripts/check-lint-count.bash b/scripts/check-lint-count.bash
new file mode 100755
index 0000000..c02f70e
--- /dev/null
+++ b/scripts/check-lint-count.bash
@@ -0,0 +1,57 @@
+#!/usr/bin/env bash
+#
+# Checks the number of lint issues against historical values. Used in
+# Travis CI builds to fail when the number increases by exploiting the
+# caching mechanism.
+
+if [[ $# != 2 || ! -f $1 ]]; then \
+ echo "Usage: $0 <lint.xml file> <historical.xml file>"
+ exit 1
+fi
+
+lint_file="$1"
+historical_file="$2"
+
+xqilla="$(which xqilla)"
+
+if [[ ! -x $xqilla ]]; then \
+ echo "Error: cannot find xqilla"
+ exit 1
+fi
+
+if [[ ! -f $historical_file ]]; then \
+ # no cache history, store this one and exit
+ cp "$lint_file" "$historical_file"
+ exit 0
+fi
+
+tmp_dir="$(mktemp -d lint.XXXXXXXX)"
+trap 'rm -rf $tmp_dir' ERR EXIT
+
+lint_results="$tmp_dir/lint.txt"
+hist_results="$tmp_dir/hist.txt"
+
+run_query() {
+ local xqilla_script='string-join(//issue/location/(concat("file=", @file, " line=", @line, " column=", @column, " reason=", ../@summary)), "&#10;")'
+ xqilla -i "$1" <(echo "$xqilla_script") | sed "s,$PWD/,,g" > "$2"
+}
+
+run_query "$lint_file" "$lint_results"
+run_query "$historical_file" "$hist_results"
+
+old_count=$(wc -l < "$hist_results")
+new_count=$(wc -l < "$lint_results")
+
+echo "Historical count: $old_count, new count: $new_count"
+
+if [[ $new_count > $old_count ]]; then \
+ echo "FAILURE: lint issues increased from $old_count to $new_count"
+ diff -u "$hist_results" "$lint_results"
+ exit 2
+fi
+
+if [[ $TRAVIS_PULL_REQUEST == false ]]; then \
+ # Okay, we either stayed the same or reduced our number.
+ # Write it out so we can check it next build!
+ cp "$lint_file" "$historical_file"
+fi